/**********************************************************/
/** MAC 122  Princpios de Desenvolvimento de Algoritmos **/
/**           IME-USP Segundo Semestre de 2006           **/
/**             T.45   Yoshiharu Kohayakawa              **/
/**               25 de Setembro de 2006                 **/
/**                                                      **/
/**      Segundo Exercicio-Programa -                    **/
/**                       Calculadora de Polinmios      **/
/**           Arquivos: numCalc.c / numCalc.h            **/
/**                                                      **/
/**            Cesar Gamboa Machado - 5638870            **/
/**********************************************************/
#include <stdlib.h>
#include <stdio.h>
#include "numCalc.h"
#include "pilha.h"

#define SIM 1
#define NAO 0

/* Copia um polinmio no-nulo */
int CopianumCalc(numCalc * orig, numCalc * dest)
{
	numCalc x, y;
	if (*orig == NULL)
		return 0;
	*dest = malloc(sizeof (**dest));
	y = *dest;
	for (x = *orig; x->next != NULL; x = x->next)
	{
		y->coef = x->coef;
		y->exp = x->exp;
		y->next = malloc(sizeof(*y));
		y = y->next;
	}
	y->coef = x->coef;
	y->exp = x->exp;
	return 1;
}
/* Desaloca um polinmio para liberar espao na memria */
int Libera(numCalc num)
{
	numCalc temp = malloc (sizeof (struct node));
	while (num != NULL)
	{
		temp = num->next;
		free(num);
		num = temp;
		
	}
	return 1;
}
/* Imprime o polinmio */
int MostranumCalc(numCalc num)
{
	numCalc x;
	int pNulo = SIM;
	if (num == NULL)
		return printf ("vazia\n");
	for (x = num; x != NULL; x = x->next)
	{
		if (x->coef == 0)
		{
			continue;
		}
		printf("%+.2lfX%d", x->coef, x->exp);
		pNulo = NAO;
	}
	if (pNulo == SIM)
		printf ("0");
	printf("\n");
	return 1;
}
/* Retorna a soma de dois polinmios */
numCalc Soma(numCalc op1, numCalc op2)
{
	numCalc x, y, z, head;
	head = malloc(sizeof *head);
	x = op1;
	y = op2;
	z = head;
	while (x != NULL && y != NULL)
	{
		if (x->exp == y->exp)
		{
			z->exp = x->exp;
			z->coef = x->coef + y->coef;
			x = x->next;
			y = y->next;
		}
		else if (x->exp < y->exp)
		{
			z->exp = y->exp;
			z->coef = y->coef;
			y = y->next;
		}
		else if (x->exp > y->exp)
		{
			z->exp = x->exp;
			z->coef = x->coef;
			x = x->next;
		}
		if (x != NULL || y != NULL)
		{
			z->next = malloc(sizeof *z);
			z = z->next;
		}
	}
	while (x != NULL)
	{
		z->exp = x->exp;
		z->coef = x->coef;
		z->next = x->next;
	}
	while (y != NULL)
	{
		z->exp = y->exp;
		z->coef = y->coef;
		z->next = y->next;
	}
	return head;
}
/* Retorna a subtrao de dois polinmios (op2 - op1) */
numCalc Subt(numCalc op1, numCalc op2)
{
	numCalc x;
	for (x = op1; x != NULL; x = x->next)
		x->coef = -(x->coef); /* O programa inverte o sinal dos expoentes de op1, e os soma com op2. */
	return Soma(op1, op2);
}
/* Retorna a multiplicao de dois polinmios */
numCalc Mult(numCalc op1, numCalc op2)
{
	numCalc head, tail, x, y;
	if (op1 == NULL || op2 == NULL)
		return 0;
	head = malloc(sizeof *head);
	tail = head;
	/* Multiplica os dois polinmios (nessa etapa o resultado
	   est fora de ordem e podem haver expoentes repetidos)  */
	for (x = op1; x != NULL; x = x->next)
	{
		for (y = op2; y != NULL; y = y->next)
		{
			tail->coef = x->coef * y->coef;
			tail->exp = x->exp + y->exp;
			tail->next = malloc(sizeof *tail);
			tail = tail->next;
		}
	}
	free(tail); /* Libera a cauda de lista que  criada */
	/* Ordena o resultado, tirando as repeties: */
	head = ordenanumCalc(head);
	return head;
}
/* Retorna a diviso de dois polinmios (op2 / op1) */
numCalc Divi(numCalc op1, numCalc op2)
{
	numCalc resto, divisor, quoc, termo, sub;
	resto = op2;
	for (divisor = op1; divisor != NULL; divisor = divisor->next)
		if (divisor->coef != 0) /* Divisor assume o primeiro valor no-nulo de op1)*/
			break;
	if (divisor == NULL)
	{
		printf("Diviso por 0. Operao no efetuada\n");
		Empilha(op2);
		return op1;
	}
	while (resto != NULL && divisor != NULL && resto->exp >= divisor->exp)
	{
		if (resto->coef == 0)
		{
			resto = resto->next;
			continue;
		}
		if (divisor->coef == 0)
		{
			divisor = divisor->next;
			continue;
		}
		termo = malloc (sizeof (*termo));
		termo->exp = resto->exp - divisor->exp;
		termo->coef = resto->coef / divisor->coef;
		quoc = Soma (quoc, termo);
		sub = Mult(termo, divisor);
		resto = Subt (sub, resto);
		if (resto->coef == 0)
			resto->exp = 0;
		if (resto->next)
			resto = resto->next;
	}
	return quoc;
}
/* Retorna o resto da diviso de dois polinomios (op2 % op1) */
numCalc Modu(numCalc op1, numCalc op2)
{
	numCalc dividendo, divisor, quociente, z, resto;
	for (divisor = op1; divisor != NULL; divisor = divisor->next)
		if (divisor->coef != 0)
			break;
	if (divisor == NULL)
	{
		printf("Diviso por 0. Operao no efetuada\n");
		Empilha(op2);
		return op1;
	}
	dividendo = op2;
	quociente = Divi(op1, op2);
	z = Mult(op1, quociente);
	resto = Subt(z, dividendo);
	return resto;
}
/* Transforma uma string em uma lista ligada */
int stringTonumCalc(char * buffer, numCalc * op)
{
	numCalc z, t;
	int i, j;
	char auxsc[50], auxse[50];
	*op = malloc(sizeof **op);
	z = *op;
	i = 0;
	while (buffer[i] != '\n' && buffer[i] != '\0')
	{
		if (buffer[i] == '+'||buffer[i] == '-')
		{
			auxsc[0] = buffer[i];
			i++;
			for (j = 1; buffer[i] != 'X' && buffer[i] != 'x'; i++, j++)
				auxsc[j] = buffer[i];
			auxsc[j] = 0;
			z->coef = atof(auxsc);
			i++;
			for (j = 0; buffer[i] != '+' && buffer[i] != '-' && buffer[i] != '\0' && buffer[i] != '\n'; i++, j++)
				auxse[j] = buffer[i];
			auxse[j] = 0;
			z->exp = atoi(auxse);
			z->next = malloc(sizeof *z);
			t = z;
			z = z->next;
		}
		else
			return 0;
	}
	t->next = NULL;
	free(z);
	return 1;
}
/*Insertion sort adaptado para retirar expoentes repetidos */
numCalc ordenanumCalc (numCalc num)
{
	numCalc ord, u, t;
	if (num == NULL)
		return NULL;
	ord = num;
	num = num->next;
	ord->next = NULL;
	t = num;
	while (num != NULL)
	{
		for (u = ord; u->next != NULL; u = u->next)
			if (t->exp >= u->next->exp)
				break;
		if (u->next != NULL && t->exp == u->next->exp)
		{
			u->next->coef = u->next->coef + t->coef;
			num = num->next;
			t = num;
		}
		else
		{
			t = num->next;
			num->next = u->next;
			u->next = num;
			num = t;
		}
	}
	return ord;
}
